module drawbox (x, y, snakex, snakey, seg1, seg2, clk, R, G, B) ;

input [9:0] x ;
input [9:0] y ;
input [9:0] snakex;
input [9:0] snakey;
input [5:0] seg1;
input [5:0] seg2;
input clk;
output R ;
output G ;
output B ;


reg snake1, snake2;         //tells us if we are within the snake or not
reg [9:0] x1, x2, y1, y2;
reg [5:0] seg2_2;
reg [9:0] snakey2, snakex2;


// add your declarations here

assign R = 0;
assign G = (snake2) ? 1 : 0;
assign B = 0;

always @(posedge clk) begin
	if(seg1[5:4] == 0) begin
	   if((y >= snakey) && (y <= (snakey + (seg1[3:0] * 20))) && (x >= snakex - 10) && (x <= snakex + 10))
	   	snake1 <= 1;
	end
	if(seg1[5:4] == 1) begin
	   if((y <= snakey) && (y >= (snakey - (seg1[3:0] * 20))) && (x >= snakex - 10) && (x <= snakex + 10))
	   	snake1 <= 1;	
	end
	if(seg1[5:4] == 2) begin
	   if((x >= snakex) && (x <= (snakex + (seg1[3:0] * 20))) && (y >= snakey - 10) && (y <= snakey + 10))
	   	snake1 <= 1;
	end
	if(seg1[5:4] == 3) begin
	   if((x <= snakex) && (x >= (snakex - (seg1[3:0] * 20))) && (y >= snakey - 10) && (y <= snakey + 10))
	   	snake1 <= 1;
	end
	
	//put values into registers for second stage of pipeline
	y2 <= y;
	x2 <= x;
	snakey2 <= snakey;
	snakex2 <= snakex;
	seg2_2 <= seg2;
	
	//check second segment coordinates and set snake accordingly   
	if(seg2_2[5:4] == 0) begin
	   if((y2 >= snakey2) && (y2 <= (snakey2 + (seg2_2[3:0] * 20))) && (x2 >= snakex2 - 10) && (x2 <= snakex2 + 10))
	   	snake2 <= 1;
	end
	else if(seg2_2[5:4] == 1) begin
	   if((y2 <= snakey2) && (y2 >= (snakey2 - (seg2_2[3:0] * 20))) && (x2 >= snakex2 - 10) && (x2 <= snakex2 + 10))
	   	snake2 <= 1;	
	end
	else if(seg2_2[5:4] == 2) begin
	   if((x2 >= snakex2) && (x2 <= (snakex2 + (seg2_2[3:0] * 20))) && (y2 >= snakey2 - 10) && (y2 <= snakey2 + 10))
	   	snake2 <= 1;
	end
	else if(seg2_2[5:4] == 3) begin
	   if((x2 <= snakex2) && (x2 >= (snakex2 - (seg2_2[3:0] * 20))) && (y2 >= snakey2 - 10) && (y2 <= snakey2 + 10))
	   	snake2 <= 1;
	end
	else   //wasn't in segment two, so pass on value of segment one.  If one of those segments is one, snake2 will be 1
		snake2 <= snake1;
end








endmodule 
